package esb.chapter11.scubadiving.test;

import javax.jms.Destination;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

import junit.framework.TestCase;

import org.apache.activemq.ActiveMQConnection;

public class ScubaDivingTest extends TestCase {
	
	public void testScubaDivingRequest() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	    Destination destination = session.createQueue("scuba.in");
		TextMessage tMessage = session.createTextMessage();
		tMessage.setText(createRequest());
		MessageProducer producer = session.createProducer(destination);
		System.out.println("sending scuba diving request");
		producer.send(tMessage);
		Destination responseDestination = session.createQueue("scuba.out");
		MessageConsumer consumer = session.createConsumer(responseDestination);
		TextMessage responseMessage = (TextMessage) consumer.receive();
		System.out.println("response " + responseMessage.getText());
	}
	
	private String createRequest() {
		String request = "<esb:ScubaDivingRequest xmlns:esb=\"http://esbinaction.com/scubadiving\">" +
  			"<esb:guestName>test</esb:guestName>" +
  			"<esb:lunchIncluded>true</esb:lunchIncluded>" +
  			"<esb:numberOfDivers>1</esb:numberOfDivers>" +
  			"<esb:interest>shark</esb:interest>" +
  			"<esb:requestDate>2008-01-30</esb:requestDate>" +
  			"<esb:roomNumber>400</esb:roomNumber>" +
  			"</esb:ScubaDivingRequest>";
		return request;
	}
}
