package esb.chapter4.component.test;

import javax.jms.Destination;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.activemq.ActiveMQConnection;
import org.junit.Before;
import org.junit.Test;

public class SimpleSpringComponentTest {
	
	private Session session;
	
	@Before
	public void initialize() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	}
	
	@Test
	public void sendEAIWord() throws Exception {
	    Destination sendDestination = session.createQueue("simpleSpring.input");
		TextMessage simpleMessage = session.createTextMessage();
		simpleMessage.setText("<word>EAI</word>");
		MessageProducer producer = session.createProducer(sendDestination);
		producer.send(simpleMessage);
	}
	
	@Test
	public void sendESBWord() throws Exception {
	    Destination sendDestination = session.createQueue("simpleSpring.input");
		TextMessage simpleMessage = session.createTextMessage();
		simpleMessage.setText("<word>ESB</word>");
		MessageProducer producer = session.createProducer(sendDestination);
		producer.send(simpleMessage);
	}

}
