package esb.chapter4.messageflow.test;

import javax.jms.Destination;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.activemq.ActiveMQConnection;
import org.apache.log4j.Logger;
import org.junit.Test;

public class MessageFlowTest {
	
	private static final Logger logger = Logger.getLogger(MessageFlowTest.class);
	
	@Test
	public void testMessageFlow() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	    Destination destination = session.createQueue("booksearch.input");
		TextMessage isbnMessage = session.createTextMessage();
		isbnMessage.setText("<isbn>1010101010</isbn>");
		MessageProducer producer = session.createProducer(destination);
		producer.send(isbnMessage);
		Destination responseDestination = session.createQueue("booksearch.output");
		MessageConsumer consumer = session.createConsumer(responseDestination);
		TextMessage quoteMessage = (TextMessage) consumer.receive();
		logger.info("received cheapest quote " + quoteMessage.getText());
		
	}

}
