package esb.chapter5.transformation.test;

import javax.jms.Destination;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

import junit.framework.TestCase;

import org.apache.activemq.ActiveMQConnection;

public class TransformationJMSTest extends TestCase {
	
	public void testTransformation() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	    Destination destination = session.createQueue("transformation.in");
		TextMessage isbnMessage = session.createTextMessage();
		isbnMessage.setText(getRequestMessage());
		MessageProducer producer = session.createProducer(destination);
		System.out.println("sending request");
		producer.send(isbnMessage);
		Destination responseDestination = session.createQueue("transformation.out");
		MessageConsumer consumer = session.createConsumer(responseDestination);
		System.out.println("receiving weather response");
		TextMessage returnMessage = (TextMessage) consumer.receive();
		System.out.println("received weather " + returnMessage.getText());
	}
	
	private String getRequestMessage() {
		return "<GetWeather xmlns=\"http://www.webserviceX.NET\">" + 
			"<CityName>Amsterdam</CityName>" +
			"<CountryName>Netherlands</CountryName>" +
			"</GetWeather>";
	}

}
