package esb.chapter8.transaction.test;

import javax.jms.Destination;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

import junit.framework.TestCase;

import org.apache.activemq.ActiveMQConnection;

public class TransactionTest extends TestCase {
	
	public void testSuccess() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	    Destination destination = session.createQueue("servicemix.transaction.in");
		TextMessage helloMessage = session.createTextMessage();
		helloMessage.setText(getTransactionMessage("started"));
		MessageProducer producer = session.createProducer(destination);
		System.out.println("sending message");
		producer.send(helloMessage);
	}
	
	public void testError() throws Exception {
		ActiveMQConnection connection = ActiveMQConnection.makeConnection("tcp://localhost:61616");
	    connection.start();
	    Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
	    Destination destination = session.createQueue("servicemix.transaction.in");
		TextMessage helloMessage = session.createTextMessage();
		helloMessage.setText(getTransactionMessage("rollback"));
		MessageProducer producer = session.createProducer(destination);
		System.out.println("sending message");
		producer.send(helloMessage);
	}
	
	private String getTransactionMessage(String status) {
		return "<transaction>" + 
			status + 
			"</transaction>";
	}

}
