package esb.chapter9.restaurant.routing.dao.hibernate;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import esb.chapter9.restaurant.routing.dao.ReservationDAOIF;
import esb.chapter9.restaurant.routing.model.Reservation;
import esb.chapter9.restaurant.routing.model.Restaurant;

public class ReservationHibernateDAO extends HibernateDaoSupport implements ReservationDAOIF {
	
	public Reservation getReservation(long reservationID) {
		return (Reservation) getHibernateTemplate().get(Reservation.class, reservationID);
	}
	
	public Reservation saveReservation(Reservation reservation) {
		String restaurantName = reservation.getRestaurant().getName();
		reservation.setRestaurant(getRestaurant(restaurantName));
		System.out.println("restaurant " + reservation.getRestaurant().getName() + ", id=" + reservation.getRestaurant().getRestaurantID());
		Long reservationId = (Long) getHibernateTemplate().save(reservation);
		return getReservation(reservationId);
	}
	
	public Restaurant getRestaurant(String name) {
		System.out.println("finding restaurant for name " + name);
		List restaurantList = getHibernateTemplate().find("from Restaurant where name = ?", new Object[]{name});
		System.out.println("retrieved list " + restaurantList);
		if(restaurantList != null)
			return (Restaurant) restaurantList.get(0);
		else
			return null;
	}

}
